      PROGRAM TDGESV3
*
*       ணࠬ PDGESV3
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER           DLEN_, IA, JA, IB, JB, IAF, JAF, IX, JX,
     $                  N, NB, RSRC, CSRC,
     $                  MXLLDA, MXLLDB, MXLLDAF, MXLLDX, NRHS, NBRHS,
     $                  NOUT, MXLOCR, MXLOCC, MXRHSC, LWORK, LIWORK
      PARAMETER         ( DLEN_ = 9, IA = 1, JA = 1, IB = 1, JB = 1,
     $                    IAF = 1, JAF = 1, IX = 1, JX = 1,
     $                  N = 9, NB = 2, RSRC = 0, CSRC = 0, MXLLDA = 5,
     $                  MXLLDB = 5, MXLLDAF = 5, MXLLDX = 5, NRHS = 1,
     $                  NBRHS = 1, NOUT = 6, MXLOCR = 5, MXLOCC = 4,
     $                  MXRHSC = 1, LIWORK = 5, LWORK = 26 )
      CHARACTER         TRANS
      PARAMETER         ( TRANS = 'N' )
      DOUBLE PRECISION  ONE
      PARAMETER         ( ONE = 1.0D+0 )
*
*  ६ ..
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
      DOUBLE PRECISION   ANORM, RNORM, EPS, RESID, XNORM
*
*  ᨢ ..
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ ),
     $                   DESCAF( DLEN_ ), DESCX( DLEN_ ),
     $                   IPIV( MXLOCR+NB )
      DOUBLE PRECISION   A( MXLLDA, MXLOCC ), A0( MXLLDA, MXLOCC ),
     $                   B( MXLLDB, MXRHSC ), B0( MXLLDB, MXRHSC ),
     $                   X( MXLLDX, MXRHSC ), AF( MXLLDAF, MXLOCC ),
     $                   FERR(1), BERR(1),
     $                   WORK2( MXLOCR ), WORK1( NB ),
     $                   WORK( LWORK ), IWORK( LIWORK )
*
* 譨 㭪樨 ..
      DOUBLE PRECISION   PDLAMCH, PDLANGE
      EXTERNAL           PDLAMCH, PDLANGE
*
* 譨 ணࠬ ..
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   DESCINIT, PDMATINIT, PDGEMM, PDGESV3, PDLACPY,
     $                   PDLAPRNT, SL_INIT
*
* ७ 㭪樨 ..
      INTRINSIC          DBLE
*
*   DATA ..
      DATA               NPROW / 2 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A, B, AF, X
*
      CALL DESCINIT( DESCA, N, N, NB, NB, RSRC, CSRC, ICTXT, MXLLDA,
     $               INFO )
      CALL DESCINIT( DESCB, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDB, INFO )
*
      CALL DESCINIT( DESCAF, N, N, NB, NB, RSRC, CSRC, ICTXT, MXLLDAF,
     $               INFO )
      CALL DESCINIT( DESCX, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDX, INFO )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
* ஢ A  B  ஢ન 離
*
      CALL PDLACPY( 'All', N, N, A, 1, 1, DESCA, A0, 1, 1, DESCA )
      CALL PDLACPY( 'All', N, NRHS, B, 1, 1, DESCB, B0, 1, 1, DESCB )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )N, N, NB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9984 ) TRANS
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  DESCAF'
         WRITE( NOUT, FMT = 9985 )DESCAF
         WRITE( NOUT, FMT = * ) '  DESCX'
         WRITE( NOUT, FMT = 9985 )DESCX
         WRITE( NOUT, FMT = * ) ' A'
      END IF
 9985 FORMAT( / 9I5 /)
 9984 FORMAT( / ' TRANS = ', A1 /)
*
      CALL PDLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      WRITE( NOUT, FMT = * ) ' B'
      END IF
      CALL PDLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1)
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL PDGESV3( TRANS, N, NRHS, A, IA, JA, DESCA, AF, IAF, JAF,
     $              DESCAF, IPIV, B, IB, JB, DESCB, X, IX, JX, DESCX,
     $              FERR, BERR, WORK, LWORK, IWORK, LIWORK, INFO )
*
*  १⮢ X 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) '襭 X'
      END IF
*
      CALL PDLAPRNT( N, NRHS, X, IX, JX, DESCX, 0, 0, 'X', NOUT, WORK1)
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      PRINT 8888, MYROW, MYCOL, FERR(1)
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
      PRINT 8887, MYROW, MYCOL, BERR(1)
      END IF
*
 8888 FORMAT( / (I2, I2, ' FERR  =', E16.8) /)
 8887 FORMAT( / (I2, I2, ' BERR  =', E16.8) /)
*
* ᫥ 離 ||A * X  - B|| / ( ||X|| * ||A|| * eps * N )
*
      EPS = PDLAMCH( ICTXT, 'Epsilon' )
      ANORM = PDLANGE( 'I', N, N, A, 1, 1, DESCA, WORK2 )
      XNORM = PDLANGE( 'I', N, NRHS, X, 1, 1, DESCX, WORK2 )
      CALL PDGEMM( 'N', 'N', N, NRHS, N, ONE, A0, 1, 1, DESCA, X,
     $             1, 1, DESCX, -ONE, B0, 1, 1, DESCB )
      RNORM = PDLANGE( 'I', N, NRHS, B0, 1, 1, DESCB, WORK2 )
      RESID = RNORM / ( ANORM*XNORM*EPS*DBLE( N ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( RESID.LT.10.0D+0 ) THEN
            WRITE( NOUT, FMT = 9995 )
            WRITE( NOUT, FMT = 9993 )RESID
         ELSE
            WRITE( NOUT, FMT = 9994 )
            WRITE( NOUT, FMT = 9993 )RESID
         END IF
      END IF
*
* ᢮ ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '   ணࠬ PDGESV3' )
 9998 FORMAT(/' 襭 A X = B ,'//'  A -  ',I2,' ',I2,',',
     $       /'      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( ' ய  ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO =', I6 /)
 9995 FORMAT( /' 離 ')
 9994 FORMAT( /' 離 ')
 9993 FORMAT( / '||A*x - b|| / ( ||x||*||A||*eps*N ) = ', 1P, E16.8 )
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।  A  B
*          ⪥ ᮢ 2 x 3
*
* ࠬ
      INTEGER            IA, IB, INFO, JA, JB, N
      INTEGER            DESCA( * ), DESCB( * )
      DOUBLE PRECISION   A( * ), B( * )
*
*  ६
      INTEGER            I, J
      DOUBLE PRECISION   AIJ, BIJ
*
* 譨 ணࠬ
      EXTERNAL           PDELSET
*
* 믮塞 
*
      INFO = 0
*
      IF( IA.NE.1 ) THEN
         INFO = -3
      ELSE IF(JA .NE.1) THEN
         INFO = -4
      END IF
*
      AIJ = 19.0D0
*
      DO 20 J = 1, N
         DO 10 I = 1, N
            IF( I.LE.J ) THEN
                CALL PDELSET( A, I, J, DESCA, AIJ )
            ELSE
                CALL PDELSET( A, I, J ,DESCA, -AIJ )
            END IF
   10 CONTINUE
         IF( J.EQ.1 .OR. J.EQ.7 ) AIJ = 3.0D0
         IF( J.EQ.2 .OR. J.EQ.4 .OR. J.EQ.6 ) AIJ = 1.0D0
         IF( J.EQ.3 ) AIJ = 12.0D0
         IF( J.EQ.5 ) AIJ = 16.0D0
         IF( J.EQ.8 ) AIJ = 11.0D0
   20 CONTINUE
*
      CALL PDELSET( A, 8, 2, DESCA, 3.0D0 )
*
      BIJ = 0.0D0
*
      J = 1
      DO 30 I = 1, N
        CALL PDELSET( B, I, J, DESCB, BIJ )
   30 CONTINUE
*
      CALL PDELSET( B, 3, 1, DESCB, 1.0D0 )
*
      RETURN
      END
